#! /bin/csh -f
### Mac OS X csh to check/load ACCES USB-DIO-32 firmware (also in loadUSB.app)

set prog = loadUSB
set iddev = USB-DIO-32
set loader = AccesLoader

### help
set helpflag = 0
if ($#argv == 1) then
 if ($1 == "-help" || $1 == "-h") set helpflag = 1
endif
if ($#argv > 2 || $helpflag) then
  echo ""
  echo "Use: loadUSB [AccesLoader_binary]"
  echo ""
  echo "   sets up Acces USB I/O box (runs AccesLoader if needed)"
  echo "   plug in USB trigger cable before (or after) running"
  echo ""
  if (`uname -s` != "Darwin") then
    echo "   N.B.: Darwin-only (runs Mac OS X /usr/sbin/system_profiler)"
  endif
  exit
endif

### 1 arg or none
if (`uname -s` != "Darwin") then
  echo "${prog}: ### Darwin-only (runs Mac OS X /usr/sbin/system_profiler)"
  exit
endif
if ($#argv == 1) then  # just bin check exists
  if (! -e $1) then
    echo "loadUSBarg: ### $1 not found"
    exit
  endif
  set loader = $1
else  # pick bin
  set proc = `uname -p`
  set rele = `uname -r` # e.g., Darwin=8.11.0
  set subdir = ""
  if ($proc == "powerpc")                  set subdir = Darwin-ppc
  if ($proc == "i386")                     set subdir = Darwin-i386
  if ($proc == "i386" && $rele:r:r >= 10)  set subdir = Darwin-x86_64
  if ($subdir == "") set subdir = Darwin-x86_64
  # if script run from Applescript, look inside bundle
  if (-e ./loadUSB.app) then
    set path = (`pwd`/loadUSB.app/Contents/MacOS/$subdir $path)
    if (`which $loader` !~ *$loader) then
      echo "${prog}: ### $loader not found inside loadUSB.app (cp error?)"
      exit
    endif
  else  # if not on path, look around
    set path = (. ../$subdir $path)
    if (`which $loader` !~ *$loader) then
      echo "${prog}: ### $loader not found (tried path, pwd, pwd/../$subdir"
    endif
  endif
endif

### only run AccesLoader if needed
set cnt = `system_profiler SPUSBDataType -detailLevel mini |grep -c $iddev`
if ($cnt == 0) then
  echo "${prog}: TTL->USB box ($iddev) not initialized"
  echo "${prog}: `which $loader`"
  echo "${prog}: plug in trigger USB cable now (if not already in)"
  set ret = `$loader`
  echo "${prog}: $ret"
  sleep 1     # don't remove
else
  echo "${prog}: TTL->USB box ($iddev) already initialized"
endif

### possibly call small C binary to zero outports (what init? all in? redo?)

